## telegram-desktop 2.1.5+ds

=== Telegram/CMakeLists.txt ===
# This file is part of Telegram Desktop,
# the official desktop application for the Telegram messaging service.
#
# For license and copyright information please follow this link:
# https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL

add_executable(Telegram WIN32 MACOSX_BUNDLE)
init_target(Telegram)

add_subdirectory(lib_rpl)
add_subdirectory(lib_crl)
add_subdirectory(lib_base)
add_subdirectory(lib_ui)
add_subdirectory(lib_tl)
if (NOT DESKTOP_APP_DISABLE_SPELLCHECK)
    add_subdirectory(lib_spellcheck)
endif()
add_subdirectory(lib_storage)
add_subdirectory(lib_lottie)
add_subdirectory(lib_qr)
add_subdirectory(codegen)

include(CheckCXXSourceCompiles)
include(lib_ui/cmake/generate_styles.cmake)
include(cmake/generate_lang.cmake)
include(cmake/generate_numbers.cmake)

get_filename_component(src_loc SourceFiles REALPATH)
get_filename_component(res_loc Resources REALPATH)

include(cmake/telegram_options.cmake)
include(cmake/lib_export.cmake)
include(cmake/lib_ffmpeg.cmake)
include(cmake/lib_mtproto.cmake)
include(cmake/lib_scheme.cmake)
include(cmake/lib_tgvoip.cmake)

set(style_files
    boxes/boxes.style
    calls/calls.style
    chat_helpers/chat_helpers.style
    dialogs/dialogs.style
    export/view/export.style
    history/history.style
    info/info.style
    intro/intro.style
    media/view/media_view.style
    media/player/media_player.style
    overview/overview.style
    passport/passport.style
    profile/profile.style
    settings/settings.style
    ui/filter_icons.style
    window/window.style
)

set(dependent_style_files
    ${submodules_loc}/lib_ui/ui/colors.palette
    ${submodules_loc}/lib_ui/ui/basic.style
    ${submodules_loc}/lib_ui/ui/layers/layers.style
    ${submodules_loc}/lib_ui/ui/widgets/widgets.style
)

generate_styles(Telegram ${src_loc} "${style_files}" "${dependent_style_files}")
generate_lang(Telegram ${res_loc}/langs/lang.strings)
generate_numbers(Telegram ${res_loc}/numbers.txt)

set_target_properties(Telegram PROPERTIES AUTOMOC ON AUTORCC ON)

if (LINUX)
    target_link_libraries(Telegram
    PRIVATE
        desktop-app::external_materialdecoration
        desktop-app::external_nimf_qt5
        desktop-app::external_qt5ct
        desktop-app::external_qt5ct_style
        desktop-app::external_qt5ct_qtplugin
    )

    if (NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
        # conflicts with Qt static link
        if (DESKTOP_APP_USE_PACKAGED_LAZY_PLATFORMTHEMES)
            target_link_libraries(Telegram
            PRIVATE
                desktop-app::external_lxqt_qtplugin
            )
        endif()

        target_link_libraries(Telegram
        PRIVATE
            desktop-app::external_statusnotifieritem
            desktop-app::external_dbusmenu_qt
            desktop-app::external_fcitx5_qt5
            desktop-app::external_hime_qt
        )
    endif()
endif()

if (add_hunspell_library)
    target_link_libraries(Telegram PRIVATE desktop-app::external_hunspell)
endif()

target_link_libraries(Telegram
PRIVATE
    tdesktop::lib_mtproto
    tdesktop::lib_scheme
    tdesktop::lib_export
    desktop-app::lib_base
    desktop-app::lib_crl
    desktop-app::lib_ui
    desktop-app::lib_tl
    desktop-app::lib_storage
    desktop-app::lib_lottie
    desktop-app::lib_qr
    desktop-app::lib_ffmpeg
    desktop-app::external_lz4
    desktop-app::external_rlottie
    desktop-app::external_zlib
    desktop-app::external_minizip
    desktop-app::external_qt
    desktop-app::external_qr_code_generator
    desktop-app::external_crash_reports
    desktop-app::external_auto_updates
    tdesktop::lib_tgvoip
    desktop-app::external_openssl
    desktop-app::external_openal
)

# Telegram uses long atomic types, so on some architectures libatomic is needed.
check_cxx_source_compiles("
#include <atomic>
std::atomic_int64_t foo;
int main() {return foo;}
" HAVE_LONG_ATOMIC_WITHOUT_LIB)
if (NOT HAVE_LONG_ATOMIC_WITHOUT_LIB)
    target_link_libraries(Telegram PRIVATE atomic)
endif()

if (DESKTOP_APP_USE_PACKAGED)
    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
    find_package(Threads REQUIRED)

    target_link_libraries(Telegram
    PRIVATE
        Threads::Threads
    )
endif()

target_precompile_headers(Telegram PRIVATE ${src_loc}/stdafx.h)
nice_target_sources(Telegram ${src_loc}
PRIVATE
    ${style_files}

    api/api_chat_filters.cpp
    api/api_chat_filters.h
    api/api_common.h
    api/api_hash.h
    api/api_self_destruct.cpp
    api/api_self_destruct.h
    api/api_sending.cpp
    api/api_sending.h
    api/api_sensitive_content.cpp
    api/api_sensitive_content.h
    api/api_single_message_search.cpp
    api/api_single_message_search.h
    api/api_text_entities.cpp
    api/api_text_entities.h
    boxes/filters/edit_filter_box.cpp
    boxes/filters/edit_filter_box.h
    boxes/filters/edit_filter_chats_list.cpp
    boxes/filters/edit_filter_chats_list.h
    boxes/peers/add_participants_box.cpp
    boxes/peers/add_participants_box.h
    boxes/peers/edit_contact_box.cpp
    boxes/peers/edit_contact_box.h
    boxes/peers/edit_linked_chat_box.cpp
    boxes/peers/edit_linked_chat_box.h
    boxes/peers/edit_participant_box.cpp
    boxes/peers/edit_participant_box.h
    boxes/peers/edit_participants_box.cpp
    boxes/peers/edit_participants_box.h
    boxes/peers/edit_peer_info_box.cpp
    boxes/peers/edit_peer_info_box.h
    boxes/peers/edit_peer_type_box.cpp
    boxes/peers/edit_peer_type_box.h
    boxes/peers/edit_peer_history_visibility_box.cpp
    boxes/peers/edit_peer_history_visibility_box.h
    boxes/peers/edit_peer_permissions_box.cpp
    boxes/peers/edit_peer_permissions_box.h
    boxes/about_box.cpp
    boxes/about_box.h
    boxes/abstract_box.cpp
    boxes/abstract_box.h
    boxes/add_contact_box.cpp
    boxes/add_contact_box.h
    boxes/auto_lock_box.cpp
    boxes/auto_lock_box.h
    boxes/auto_download_box.cpp
    boxes/auto_download_box.h
    boxes/background_box.cpp
    boxes/background_box.h
    boxes/background_preview_box.cpp
    boxes/background_preview_box.h
    boxes/calendar_box.cpp
    boxes/calendar_box.h
    boxes/change_phone_box.cpp
    boxes/change_phone_box.h
    boxes/confirm_box.cpp
    boxes/confirm_box.h
    boxes/confirm_phone_box.cpp
    boxes/confirm_phone_box.h
    boxes/connection_box.cpp
    boxes/connection_box.h
    boxes/create_poll_box.cpp
    boxes/create_poll_box.h
    boxes/dictionaries_manager.cpp
    boxes/dictionaries_manager.h
    boxes/download_path_box.cpp
    boxes/download_path_box.h
    boxes/edit_caption_box.cpp
    boxes/edit_caption_box.h
    boxes/edit_color_box.cpp
    boxes/edit_color_box.h
    boxes/edit_privacy_box.cpp
    boxes/edit_privacy_box.h
    boxes/language_box.cpp
    boxes/language_box.h
    boxes/local_storage_box.cpp
    boxes/local_storage_box.h
    boxes/mute_settings_box.cpp
    boxes/mute_settings_box.h
    boxes/peer_list_box.cpp
    boxes/peer_list_box.h
    boxes/peer_list_controllers.cpp
    boxes/peer_list_controllers.h
    boxes/passcode_box.cpp
    boxes/passcode_box.h
    boxes/photo_crop_box.cpp
    boxes/photo_crop_box.h
    boxes/rate_call_box.cpp
    boxes/rate_call_box.h
    boxes/report_box.cpp
    boxes/report_box.h
    boxes/self_destruction_box.cpp
    boxes/self_destruction_box.h
    boxes/send_files_box.cpp
    boxes/send_files_box.h
    boxes/sessions_box.cpp
    boxes/sessions_box.h
    boxes/share_box.cpp
    boxes/share_box.h
    boxes/single_choice_box.cpp
    boxes/single_choice_box.h
    boxes/sticker_set_box.cpp
    boxes/sticker_set_box.h
    boxes/stickers_box.cpp
    boxes/stickers_box.h
    boxes/url_auth_box.cpp
    boxes/url_auth_box.h
    boxes/username_box.cpp
    boxes/username_box.h
    calls/calls_box_controller.cpp
    calls/calls_box_controller.h
    calls/calls_call.cpp
    calls/calls_call.h
    calls/calls_emoji_fingerprint.cpp
    calls/calls_emoji_fingerprint.h
    calls/calls_instance.cpp
    calls/calls_instance.h
    calls/calls_panel.cpp
    calls/calls_panel.h
    calls/calls_top_bar.cpp
    calls/calls_top_bar.h
    chat_helpers/bot_keyboard.cpp
    chat_helpers/bot_keyboard.h
    chat_helpers/emoji_keywords.cpp
    chat_helpers/emoji_keywords.h
    chat_helpers/emoji_list_widget.cpp
    chat_helpers/emoji_list_widget.h
    chat_helpers/emoji_sets_manager.cpp
    chat_helpers/emoji_sets_manager.h
    chat_helpers/emoji_suggestions_widget.cpp
    chat_helpers/emoji_suggestions_widget.h
    chat_helpers/field_autocomplete.cpp
    chat_helpers/field_autocomplete.h
    chat_helpers/gifs_list_widget.cpp
    chat_helpers/gifs_list_widget.h
    chat_helpers/message_field.cpp
    chat_helpers/message_field.h
    chat_helpers/spellchecker_common.cpp
    chat_helpers/spellchecker_common.h
    chat_helpers/stickers.cpp
    chat_helpers/stickers.h
    chat_helpers/stickers_emoji_pack.cpp
    chat_helpers/stickers_emoji_pack.h
    chat_helpers/stickers_dice_pack.cpp
    chat_helpers/stickers_dice_pack.h
    chat_helpers/stickers_list_widget.cpp
    chat_helpers/stickers_list_widget.h
    chat_helpers/tabbed_panel.cpp
    chat_helpers/tabbed_panel.h
    chat_helpers/tabbed_section.cpp
    chat_helpers/tabbed_section.h
    chat_helpers/tabbed_selector.cpp
    chat_helpers/tabbed_selector.h
    core/application.cpp
    core/application.h
    core/base_integration.cpp
    core/base_integration.h
    core/changelogs.cpp
    core/changelogs.h
    core/click_handler_types.cpp
    core/click_handler_types.h
    core/core_cloud_password.cpp
    core/core_cloud_password.h
    core/core_settings.cpp
    core/core_settings.h
    core/crash_report_window.cpp
    core/crash_report_window.h
    core/crash_reports.cpp
    core/crash_reports.h
    core/file_utilities.cpp
    core/file_utilities.h
    core/launcher.cpp
    core/launcher.h
    core/local_url_handlers.cpp
    core/local_url_handlers.h
    core/media_active_cache.h
    core/mime_type.cpp
    core/mime_type.h
    core/sandbox.cpp
    core/sandbox.h
    core/shortcuts.cpp
    core/shortcuts.h
    core/ui_integration.cpp
    core/ui_integration.h
    core/update_checker.cpp
    core/update_checker.h
    core/utils.cpp
    core/utils.h
    core/version.h
    data/data_abstract_structure.cpp
    data/data_abstract_structure.h
    data/data_auto_download.cpp
    data/data_auto_download.h
    data/data_chat.cpp
    data/data_chat.h
    data/data_chat_filters.cpp
    data/data_chat_filters.h
    data/data_channel.cpp
    data/data_channel.h
    data/data_channel_admins.cpp
    data/data_channel_admins.h
    data/data_cloud_themes.cpp
    data/data_cloud_themes.h
    data/data_countries.cpp
    data/data_countries.h
    data/data_document.cpp
    data/data_document.h
    data/data_document_good_thumbnail.cpp
    data/data_document_good_thumbnail.h
    data/data_drafts.cpp
    data/data_drafts.h
    data/data_folder.cpp
    data/data_folder.h
    # data/data_feed_messages.cpp
    # data/data_feed_messages.h
    data/data_file_origin.cpp
    data/data_file_origin.h
    data/data_flags.h
    data/data_game.h
    data/data_groups.cpp
    data/data_groups.h
    data/data_histories.cpp
    data/data_histories.h
    data/data_location.cpp
    data/data_location.h
    data/data_media_rotation.cpp
    data/data_media_rotation.h
    data/data_media_types.cpp
    data/data_media_types.h
    data/data_messages.cpp
    data/data_messages.h
    data/data_notify_settings.cpp
    data/data_notify_settings.h
    data/data_peer.cpp
    data/data_peer.h
    data/data_peer_values.cpp
    data/data_peer_values.h
    data/data_photo.cpp
    data/data_photo.h
    data/data_poll.cpp
    data/data_poll.h
    data/data_pts_waiter.cpp
    data/data_pts_waiter.h
    data/data_search_controller.cpp
    data/data_search_controller.h
    data/data_session.cpp
    data/data_session.h
    data/data_scheduled_messages.cpp
    data/data_scheduled_messages.h
    data/data_shared_media.cpp
    data/data_shared_media.h
    data/data_sparse_ids.cpp
    data/data_sparse_ids.h
    data/data_streaming.cpp
    data/data_streaming.h

=== cmake/external/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

macro(add_checked_subdirectory name)
    if (NOT DEFINED desktop_app_skip_libs
        OR NOT ${name} IN_LIST desktop_app_skip_libs)
        add_subdirectory(${name})
    endif()
endmacro()

add_checked_subdirectory(auto_updates)
add_checked_subdirectory(crash_reports)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(dbusmenu_qt)
endif()
add_checked_subdirectory(expected)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(fcitx_qt5)
    add_checked_subdirectory(fcitx5_qt5)
    add_checked_subdirectory(fcitx5_qt5_dbusaddons)
endif()
add_checked_subdirectory(ffmpeg)
add_checked_subdirectory(gsl)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(hime_im_client)
    add_checked_subdirectory(hime_qt)
endif()
if (add_hunspell_library)
	add_checked_subdirectory(hunspell)
endif()
add_checked_subdirectory(iconv)
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(lxqt_qtplugin)
endif()
add_checked_subdirectory(lz4)
if (LINUX)
    add_checked_subdirectory(materialdecoration)
endif()
add_checked_subdirectory(minizip)
if (LINUX)
    add_checked_subdirectory(nimf_qt5)
endif()
add_checked_subdirectory(openal)
add_checked_subdirectory(openssl)
add_checked_subdirectory(opus)
add_checked_subdirectory(qt)
if (LINUX)
    add_checked_subdirectory(qt5ct)
    add_checked_subdirectory(qt5ct_qtplugin)
    add_checked_subdirectory(qt5ct_style)
endif()
add_checked_subdirectory(qr_code_generator)
add_checked_subdirectory(ranges)
add_checked_subdirectory(rlottie)
if (APPLE)
    add_checked_subdirectory(sp_media_key_tap)
endif()
if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
    add_checked_subdirectory(statusnotifieritem)
endif()
add_checked_subdirectory(ton)
add_checked_subdirectory(variant)
if (LINUX)
    add_checked_subdirectory(xdgiconloader)
endif()
add_checked_subdirectory(xxhash)
add_checked_subdirectory(zlib)

=== cmake/external/fcitx5_qt5/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
    add_library(external_fcitx5_qt5 INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_fcitx5_qt5 ALIAS external_fcitx5_qt5)
else()
    add_library(external_fcitx5_qt5 STATIC)
    add_library(desktop-app::external_fcitx5_qt5 ALIAS external_fcitx5_qt5)
    init_target(external_fcitx5_qt5 "(external)")

    set(fcitx5_qt_loc ${third_party_loc}/fcitx5-qt)
    set(fcitx5_qt5_src ${fcitx5_qt_loc}/qt5/platforminputcontext)

    set_target_properties(external_fcitx5_qt5 PROPERTIES AUTOMOC ON)

    nice_target_sources(external_fcitx5_qt5 ${fcitx5_qt5_src}
    PRIVATE
        qfcitxplatforminputcontext.cpp
        qfcitxplatforminputcontext.h
        qtkey.cpp
        main.cpp
        main.h
    )

    target_include_directories(external_fcitx5_qt5
    PRIVATE
        ${fcitx5_qt5_src}
    )

    target_compile_definitions(external_fcitx5_qt5
    PRIVATE
        QT_STATICPLUGIN
    )

    target_link_libraries(external_fcitx5_qt5
    PRIVATE
        desktop-app::external_fcitx5_qt5_dbusaddons
        desktop-app::external_qt
    )

    if (DESKTOP_APP_USE_PACKAGED)
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon)
        pkg_check_modules(XCB REQUIRED IMPORTED_TARGET xcb)

        target_link_libraries(external_fcitx5_qt5
        PRIVATE
            PkgConfig::XKBCOMMON
            PkgConfig::XCB
        )
    else()
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(XKBCOMMON REQUIRED xkbcommon)
        pkg_check_modules(XCB REQUIRED xcb)

        target_include_directories(external_fcitx5_qt5
        PUBLIC
            ${XKBCOMMON_INCLUDE_DIRS}
            ${XCB_INCLUDE_DIRS}
        )

        target_link_static_libraries(external_fcitx5_qt5
        PRIVATE
            xkbcommon
        )

        target_link_libraries(external_fcitx5_qt5
        PRIVATE
            xcb
        )
    endif()
endif()

=== cmake/external/fcitx5_qt5_dbusaddons/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
    add_library(external_fcitx5_qt5_dbusaddons INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_fcitx5_qt5_dbusaddons ALIAS external_fcitx5_qt5_dbusaddons)
else()
    add_library(external_fcitx5_qt5_dbusaddons OBJECT)
    add_library(desktop-app::external_fcitx5_qt5_dbusaddons ALIAS external_fcitx5_qt5_dbusaddons)
    init_target(external_fcitx5_qt5_dbusaddons "(external)")

    set(fcitx5_qt_loc ${third_party_loc}/fcitx5-qt)
    set(fcitx5_qt5_dbusaddons_src ${fcitx5_qt_loc}/qt5/dbusaddons)

    set_target_properties(external_fcitx5_qt5_dbusaddons PROPERTIES AUTOMOC ON)

    nice_target_sources(external_fcitx5_qt5_dbusaddons ${fcitx5_qt5_dbusaddons_src}
    PRIVATE
        fcitxqtwatcher.cpp
        fcitxqtwatcher.h
        fcitxqtdbustypes.cpp
        fcitxqtdbustypes.h
        fcitxqtinputcontextproxy.cpp
        fcitxqtinputcontextproxy.h
        fcitxqtinputcontextproxyimpl.cpp
        fcitxqtinputmethodproxy.cpp
        fcitxqtinputmethodproxy.h
        fcitxqtcontrollerproxy.cpp
        fcitxqtcontrollerproxy.h
    )

    include(GenerateExportHeader)
    generate_export_header(external_fcitx5_qt5_dbusaddons BASE_NAME Fcitx5Qt5DBusAddons)

    target_include_directories(external_fcitx5_qt5_dbusaddons
    PUBLIC
        ${fcitx5_qt_loc}/common
        ${fcitx5_qt5_dbusaddons_src}
        "${CMAKE_CURRENT_BINARY_DIR}"
    )

    target_compile_definitions(external_fcitx5_qt5_dbusaddons
    PRIVATE
        FCITX5QT5DBUSADDONS_STATIC_DEFINE
    )

    target_link_libraries(external_fcitx5_qt5_dbusaddons
    PRIVATE
        desktop-app::external_qt
    )
endif()

=== cmake/external/hime_im_client/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
    add_library(external_hime_im_client INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_hime_im_client ALIAS external_hime_im_client)
else()
    add_library(external_hime_im_client OBJECT)
    add_library(desktop-app::external_hime_im_client ALIAS external_hime_im_client)
    init_target(external_hime_im_client "(external)")

    set(hime_loc ${third_party_loc}/hime)
    set(hime_src ${hime_loc}/src)
    set(hime_im_client_src ${hime_src}/im-client)

    nice_target_sources(external_hime_im_client ${hime_im_client_src}
    PRIVATE
        hime-im-client-attr.h
        hime-im-client.c
        hime-im-client.h
        hime-protocol.h
        hime-send.c
    )

    nice_target_sources(external_hime_im_client ${hime_src}
    PRIVATE
        hime-conf.c
        util.c
        im-addr.c
        hime-crypt.c
    )

    find_package(PkgConfig REQUIRED)
    pkg_search_module(GTK REQUIRED gtk+-2.0 gtk+-3.0)

    target_include_directories(external_hime_im_client
    PUBLIC
        ${hime_im_client_src}
    PRIVATE
        ${hime_src}
        ${hime_src}/IMdkit/include
        ${GTK_INCLUDE_DIRS}
    )

    target_compile_definitions(external_hime_im_client
    PRIVATE
        HIME_BIN_DIR="/usr/bin"
        HIME_TABLE_DIR="/usr/share/hime/table"
        UNIX=1
        FREEBSD=0
        CLIENT_LIB=1
    )

    if (DESKTOP_APP_USE_PACKAGED)
        pkg_check_modules(X11 REQUIRED IMPORTED_TARGET x11)
        pkg_check_modules(GLIB2 REQUIRED IMPORTED_TARGET glib-2.0)

        target_link_libraries(external_hime_im_client
        PUBLIC
            PkgConfig::X11
            PkgConfig::GLIB2
        )
    else()
        pkg_check_modules(X11 REQUIRED x11)
        pkg_check_modules(GLIB2 REQUIRED glib-2.0)

        target_include_directories(external_hime_im_client
        PUBLIC
            ${X11_INCLUDE_DIRS}
            ${GLIB2_INCLUDE_DIRS}
        )

        target_link_libraries(external_hime_im_client
        PUBLIC
            X11
            glib-2.0
        )
    endif()
endif()

=== cmake/external/qt/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_qt INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_qt ALIAS external_qt)

if (LINUX)
    if (NOT build_linux32)
        target_compile_definitions(external_qt INTERFACE Q_OS_LINUX64)
    else()
        target_compile_definitions(external_qt INTERFACE Q_OS_LINUX32)
    endif()
endif()

if (DESKTOP_APP_USE_PACKAGED)
    target_link_libraries(external_qt
    INTERFACE
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Network
    )

    target_include_directories(external_qt
    INTERFACE
        ${Qt5Core_PRIVATE_INCLUDE_DIRS}
        ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    )

    if (Qt5DBus_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::DBus)
    endif()

    if (Qt5Svg_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::Svg)
    endif()

    if (LINUX AND DESKTOP_APP_USE_PACKAGED_LAZY_PLATFORMTHEMES)
        find_library(Qt5ThemeSupport_LIBRARY
        NAMES
            Qt5ThemeSupport
        )

        find_path(Qt5ThemeSupport_INCLUDE_DIR
        NAMES
            QtThemeSupport/private/qgenericunixthemes_p.h
        HINTS
            ${Qt5Gui_INCLUDE_DIRS}
        PATH_SUFFIXES
            QtThemeSupport/${Qt5Gui_VERSION}
        )

        target_link_libraries(external_qt
        INTERFACE
            ${Qt5ThemeSupport_LIBRARY}
        )

        target_include_directories(external_qt
        INTERFACE
            ${Qt5ThemeSupport_INCLUDE_DIR}
            ${Qt5ThemeSupport_INCLUDE_DIR}/QtThemeSupport
        )
    endif()

    if (Qt5WaylandClient_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::WaylandClient)

        target_include_directories(external_qt
        INTERFACE
            ${Qt5WaylandClient_PRIVATE_INCLUDE_DIRS}
        )
    endif()

    if (Qt5X11Extras_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::X11Extras)
    endif()
else()
    target_include_directories(external_qt SYSTEM
    INTERFACE
        ${qt_loc}/include
        ${qt_loc}/include/QtCore
        ${qt_loc}/include/QtGui
        ${qt_loc}/include/QtWidgets
        ${qt_loc}/include/QtCore/${qt_version}
        ${qt_loc}/include/QtGui/${qt_version}
        ${qt_loc}/include/QtCore/${qt_version}/QtCore
        ${qt_loc}/include/QtGui/${qt_version}/QtGui
    )

    if (Qt5DBus_FOUND)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/include/QtDBus
        )
    endif()

    if (LINUX)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/include/QtSvg
            ${qt_loc}/include/QtThemeSupport
            ${qt_loc}/include/QtWaylandClient
            ${qt_loc}/include/QtX11Extras
            ${qt_loc}/include/QtThemeSupport/${qt_version}
            ${qt_loc}/include/QtWaylandClient/${qt_version}
            ${qt_loc}/include/QtThemeSupport/${qt_version}/QtThemeSupport
            ${qt_loc}/include/QtWaylandClient/${qt_version}/QtWaylandClient
        )
    endif()

    target_compile_definitions(external_qt
    INTERFACE
        _REENTRANT
        QT_STATICPLUGIN
        QT_PLUGIN
        QT_WIDGETS_LIB
        QT_NETWORK_LIB
        QT_GUI_LIB
        QT_CORE_LIB
    )

    if (Qt5DBus_FOUND)
        target_compile_definitions(external_qt
        INTERFACE
            QT_DBUS_LIB
        )
    endif()

    if (LINUX)
        target_compile_definitions(external_qt
        INTERFACE
            QT_WAYLANDCLIENT_LIB
            QT_THEME_SUPPORT_LIB
            QT_SVG_LIB
            QT_X11EXTRAS_LIB
        )
    endif()

    if (WIN32)
        set(qt_lib_prefix "")
        set(qt_lib_suffix $<$<CONFIG:Debug>:d>.lib)
    else()
        set(qt_lib_prefix lib)
        if (APPLE)
            set(qt_lib_suffix $<$<CONFIG:Debug>:_debug>.a)
        else()
            set(qt_lib_suffix .a)
        endif()
    endif()

    set(common_qt_libs
        plugins/imageformats/${qt_lib_prefix}qwebp
        plugins/imageformats/${qt_lib_prefix}qgif
        plugins/imageformats/${qt_lib_prefix}qjpeg
        lib/${qt_lib_prefix}Qt5PrintSupport
        lib/${qt_lib_prefix}Qt5AccessibilitySupport
        lib/${qt_lib_prefix}Qt5FontDatabaseSupport
        lib/${qt_lib_prefix}Qt5EventDispatcherSupport
        lib/${qt_lib_prefix}Qt5ThemeSupport
        lib/${qt_lib_prefix}Qt5Network
        lib/${qt_lib_prefix}Qt5Widgets
        lib/${qt_lib_prefix}Qt5Gui
        lib/${qt_lib_prefix}qtharfbuzz
        lib/${qt_lib_prefix}qtlibpng
    )

    set(qt_libs_list "")
    if (WIN32)
        set(qt_libs
            ${common_qt_libs}
            lib/${qt_lib_prefix}Qt5Core
            lib/${qt_lib_prefix}Qt5WindowsUIAutomationSupport
            lib/${qt_lib_prefix}qtmain
            lib/${qt_lib_prefix}qtfreetype
            lib/${qt_lib_prefix}qtpcre2
            plugins/platforms/${qt_lib_prefix}qwindows
        )
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
    elseif (APPLE)
        if (NOT build_osx)
            set(qt_libs
                ${common_qt_libs}
                lib/${qt_lib_prefix}Qt5Core
                lib/${qt_lib_prefix}Qt5GraphicsSupport
                lib/${qt_lib_prefix}Qt5ClipboardSupport
                lib/${qt_lib_prefix}qtfreetype
                lib/${qt_lib_prefix}qtpcre2
                plugins/platforms/${qt_lib_prefix}qcocoa
                plugins/bearer/${qt_lib_prefix}qgenericbearer
            )
        else()
            set(qt_libs
                lib/${qt_lib_prefix}Qt5PrintSupport
                lib/${qt_lib_prefix}Qt5PlatformSupport
                lib/${qt_lib_prefix}Qt5Network
                lib/${qt_lib_prefix}Qt5Widgets
                lib/${qt_lib_prefix}Qt5Gui
                lib/${qt_lib_prefix}Qt5Core
                lib/${qt_lib_prefix}qtharfbuzzng
                lib/${qt_lib_prefix}qtfreetype
                lib/${qt_lib_prefix}qtpcre
                plugins/platforms/${qt_lib_prefix}qcocoa
                plugins/imageformats/${qt_lib_prefix}qwebp
                plugins/bearer/${qt_lib_prefix}qgenericbearer
            )
        endif()
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
        target_link_libraries(external_qt
        INTERFACE
            desktop-app::external_zlib
            cups
        )
    else()
        set(qt_libs_dbus)
        set(qt_libs_dbus_support)
        set(qt_libs_dbus_plugins)
        set(qt_libs_dbus_bearers)
        if (Qt5DBus_FOUND)
            set(qt_libs_dbus lib/${qt_lib_prefix}Qt5DBus)
            set(qt_libs_dbus_support lib/${qt_lib_prefix}Qt5LinuxAccessibilitySupport)
            set(qt_libs_dbus_plugins
                plugins/platforminputcontexts/${qt_lib_prefix}ibusplatforminputcontextplugin
                plugins/platformthemes/${qt_lib_prefix}qxdgdesktopportal
            )
            set(qt_libs_dbus_bearers
                plugins/bearer/${qt_lib_prefix}qconnmanbearer
                plugins/bearer/${qt_lib_prefix}qnmbearer
            )
        endif()
        set(qt_libs
            plugins/platforminputcontexts/${qt_lib_prefix}composeplatforminputcontextplugin
            ${qt_libs_dbus_plugins}
            plugins/wayland-decoration-client/${qt_lib_prefix}bradient
            plugins/wayland-shell-integration/${qt_lib_prefix}ivi-shell
            plugins/wayland-shell-integration/${qt_lib_prefix}wl-shell
            plugins/wayland-shell-integration/${qt_lib_prefix}xdg-shell-v5
            plugins/wayland-shell-integration/${qt_lib_prefix}xdg-shell-v6
            plugins/wayland-shell-integration/${qt_lib_prefix}xdg-shell
            plugins/wayland-graphics-integration-client/${qt_lib_prefix}qt-plugin-wayland-egl
            plugins/wayland-graphics-integration-client/${qt_lib_prefix}drm-egl-server
            plugins/wayland-graphics-integration-client/${qt_lib_prefix}dmabuf-server
            plugins/wayland-graphics-integration-client/${qt_lib_prefix}shm-emulation-server
            plugins/platforms/${qt_lib_prefix}qwayland-egl
            plugins/platforms/${qt_lib_prefix}qwayland-generic
            plugins/platforms/${qt_lib_prefix}qxcb
            plugins/imageformats/${qt_lib_prefix}qsvg
            plugins/iconengines/${qt_lib_prefix}qsvgicon
            lib/${qt_lib_prefix}Qt5XcbQpa
            lib/${qt_lib_prefix}Qt5EglSupport
            lib/${qt_lib_prefix}Qt5ServiceSupport
            lib/${qt_lib_prefix}Qt5EdidSupport
            ${qt_libs_dbus_support}
            plugins/bearer/${qt_lib_prefix}qgenericbearer
            ${qt_libs_dbus_bearers}
            lib/${qt_lib_prefix}Qt5X11Extras
            lib/${qt_lib_prefix}Qt5WaylandClient
            ${common_qt_libs}
            ${qt_libs_dbus}
            lib/${qt_lib_prefix}Qt5Svg
            lib/${qt_lib_prefix}Qt5Core
            lib/${qt_lib_prefix}qtpcre2
            lib/${qt_lib_prefix}xcb-static
        )
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
    endif()

    target_link_libraries(external_qt
    INTERFACE
        ${qt_libs_list}
    )

    if (LINUX)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/mkspecs/linux-g++
        )
        target_link_options(external_qt
        INTERFACE
            -static-libstdc++
            -pthread
            -rdynamic
        )
        if (DESKTOP_APP_USE_GLIBC_WRAPS)
            target_link_options(external_qt
            INTERFACE
                -Wl,-wrap,aligned_alloc
                -Wl,-wrap,secure_getenv
                -Wl,-wrap,clock_gettime
                -Wl,--no-as-needed,-lrt
            )
            if (NOT build_linux32)
                target_link_options(external_qt
                INTERFACE
                    -Wl,-wrap,__divmodti4
                )
            else()
                target_link_options(external_qt
                INTERFACE
                    -Wl,-wrap,__divmoddi4
                )
            endif()
        endif()
        target_link_static_libraries(external_qt
        INTERFACE
            wayland-egl
            wayland-cursor
            wayland-client
            xcb-shm
            xcb-xfixes
            xcb-render
            xkbcommon
            xkbcommon-x11
            Xrender
            ffi
            icutu
            icui18n
            icuuc
            icudata
        )
        if (DESKTOP_APP_USE_GLIBC_WRAPS)
            target_link_libraries(external_qt
            INTERFACE
                desktop-app::linux_glibc_wraps
                $<TARGET_FILE:desktop-app::linux_glibc_wraps>
            )
        endif()
        target_link_libraries(external_qt
        INTERFACE
            ICE
            SM
            fontconfig
            freetype
            EGL
            GL
            xcb
            X11
            X11-xcb
            dl
            glib-2.0
            pthread
        )
    endif()
endif()

=== cmake/external/rlottie/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED_RLOTTIE AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
    add_library(external_rlottie INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_rlottie ALIAS external_rlottie)

    find_package(PkgConfig REQUIRED)
    pkg_check_modules(RLOTTIE REQUIRED IMPORTED_TARGET rlottie)
    target_link_libraries(external_rlottie INTERFACE PkgConfig::RLOTTIE)
else()
    add_library(external_rlottie OBJECT)
    add_library(desktop-app::external_rlottie ALIAS external_rlottie)
    init_target(external_rlottie "(external)")

    get_filename_component(src_loc . REALPATH)
    set(rlottie_loc ${third_party_loc}/rlottie)

    target_sources(external_rlottie PRIVATE ${src_loc}/config/config.h)
    nice_target_sources(external_rlottie ${rlottie_loc}
    PRIVATE
        inc/rlottie.h
        inc/rlottie_capi.h
        inc/rlottiecommon.h

        src/lottie/lottieanimation.cpp
        src/lottie/lottieitem.cpp
        src/lottie/lottieitem.h
        src/lottie/lottiekeypath.cpp
        src/lottie/lottiekeypath.h
        src/lottie/lottieloader.cpp
        src/lottie/lottieloader.h
        src/lottie/lottiemodel.cpp
        src/lottie/lottiemodel.h
        src/lottie/lottieparser.cpp
        src/lottie/lottieparser.h
        src/lottie/lottieproxymodel.cpp
        src/lottie/lottieproxymodel.h

        src/vector/freetype/v_ft_math.cpp
        src/vector/freetype/v_ft_math.h
        src/vector/freetype/v_ft_raster.cpp
        src/vector/freetype/v_ft_raster.h
        src/vector/freetype/v_ft_stroker.cpp
        src/vector/freetype/v_ft_stroker.h
        src/vector/freetype/v_ft_types.h

        # src/vector/pixman/pixman-arm-neon-asm.h
        # src/vector/pixman/pixman-arm-neon-asm.S
        src/vector/pixman/vregion.cpp
        src/vector/pixman/vregion.h

        src/vector/vbezier.cpp
        src/vector/vbezier.h
        src/vector/vbitmap.cpp
        src/vector/vbitmap.h
        src/vector/vbrush.cpp
        src/vector/vbrush.h
        src/vector/vcompositionfunctions.cpp
        src/vector/vcowptr.h
        src/vector/vdasher.cpp
        src/vector/vdasher.h
        src/vector/vdebug.cpp
        src/vector/vdebug.h
        src/vector/vdrawable.cpp
        src/vector/vdrawable.h
        src/vector/vdrawhelper.cpp
        src/vector/vdrawhelper.h
        src/vector/vdrawhelper_neon.cpp
        src/vector/vdrawhelper_sse2.cpp
        src/vector/velapsedtimer.cpp
        src/vector/velapsedtimer.h
        src/vector/vglobal.h
        src/vector/vimageloader.cpp
        src/vector/vimageloader.h
        src/vector/vinterpolator.cpp
        src/vector/vinterpolator.h
        src/vector/vline.h
        src/vector/vmatrix.cpp
        src/vector/vmatrix.h
        src/vector/vpainter.cpp
        src/vector/vpainter.h
        src/vector/vpath.cpp
        src/vector/vpath.h
        src/vector/vpathmesure.cpp
        src/vector/vpathmesure.h
        src/vector/vpoint.h
        src/vector/vraster.cpp
        src/vector/vraster.h
        src/vector/vrect.cpp
        src/vector/vrect.h
        src/vector/vrle.cpp
        src/vector/vrle.h
        src/vector/vstackallocator.h
        src/vector/vtaskqueue.h
    )

    target_compile_definitions(external_rlottie
    PUBLIC
        LOT_BUILD
    PRIVATE
        _USE_MATH_DEFINES
        "RAPIDJSON_ASSERT=(void)"
    )

    target_include_directories(external_rlottie
    PUBLIC
        ${rlottie_loc}/inc
    PRIVATE
        ${src_loc}/config
        ${rlottie_loc}/src/lottie
        ${rlottie_loc}/src/vector
        ${rlottie_loc}/src/vector/pixman
        ${rlottie_loc}/src/vector/freetype
    )

    if (LINUX)
        target_link_libraries(external_rlottie
        PUBLIC
            pthread
        )
    endif()

    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        target_compile_options(external_rlottie
        PRIVATE
            /w44244 # 'initializing': conversion from 'double' to 'float'
            /w44251 # needs to have dll-interface to be used by clients of class
        )
    endif()
endif()

=== debian/changelog ===
telegram-desktop (2.1.5+ds-1) unstable; urgency=medium

  * New upstream release.
  * Remove no longer needed Reduce-boldface.patch.
  * Revert "Remove no longer needed Ignore-emoji-pack.patch".
    - So far, Telegram Desktop will use on ia64 architecture the
      rlottie::Animition::loadFromData method with old signature.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 19 May 2020 22:07:41 +0300

## telegram-desktop 2.1.6+ds

=== debian/changelog ===
telegram-desktop (2.1.6+ds-0.1~mx19+1) mx; urgency=medium

  * New upstream release.
  * Disable Reduce-boldface.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 15 May 2020 20:15:42 -0700

=== debian/control ===
Source: telegram-desktop
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (=12)
Build-Depends-Arch:
 cmake (>=3.16.0),
 libavcodec-dev (>=7:3.2),
 libavformat-dev (>=7:3.2),
 libavutil-dev (>=7:3.2),
 libdbusmenu-qt5-dev,
 libexpected-dev,
 libgtk2.0-dev,
 libhunspell-dev,
 liblz4-dev,
 liblzma-dev,
 libmapbox-variant-dev,
 libminizip-dev (>=1.1),
 libmsgsl-dev (>=3.0.0),
 libopenal-dev,
 libopus-dev (>=1.1),
 libqrcodegencpp-dev,
 librange-v3-dev (>=0.10.0),
 librlottie-dev (>= 0~git20200305.a717479~),
 libssl-dev (>=1.0.1),
 libswresample-dev (>=7:3.2),
 libswscale-dev (>=7:3.2),
 libtgvoip-dev (>=2.4.4),
 libxxhash-dev,
 qtbase5-dev (>=5.9.0),
 qtbase5-private-dev (>=5.9.0),
 zlib1g-dev (>=1:1.2.8),
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://desktop.telegram.org
Vcs-Git: https://salsa.debian.org/debian/telegram-desktop.git
Vcs-Browser: https://salsa.debian.org/debian/telegram-desktop

Package: telegram-desktop
# Only little endian is supported.
Architecture: amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64el mipsel ppc64el riscv64 sh4 x32
Depends: qt5-image-formats-plugins (>=5.9.0), ${misc:Depends}, ${shlibs:Depends}
Recommends: fonts-open-sans
Built-Using: ${cpplibs:Built-Using}
Description: fast and secure messaging application
 Telegram is a messaging app with a focus on speed and security, it is
 super-fast, simple and free. You can use Telegram on all your devices at the
 same time — your messages sync seamlessly across any number of your phones,
 tablets or computers.

## telegram-desktop 2.1.7+ds

=== Telegram/CMakeLists.txt ===
--- 
+++ 
@@ -90,6 +90,7 @@
         PRIVATE
             desktop-app::external_statusnotifieritem
             desktop-app::external_dbusmenu_qt
+            desktop-app::external_fcitx_qt5
             desktop-app::external_fcitx5_qt5
             desktop-app::external_hime_qt
         )
@@ -403,5 +404,3 @@
     data/data_shared_media.h
     data/data_sparse_ids.cpp
     data/data_sparse_ids.h
-    data/data_streaming.cpp
-    data/data_streaming.h

=== cmake/external/fcitx5_qt5/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,9 @@
 
     set_target_properties(external_fcitx5_qt5 PROPERTIES AUTOMOC ON)
 
+    set(FCITX5_QT_EXTRA_PLUGIN_NAME "")
+    configure_file("${fcitx5_qt5_src}/fcitx5.json.in" "${CMAKE_CURRENT_BINARY_DIR}/fcitx5.json")
+
     nice_target_sources(external_fcitx5_qt5 ${fcitx5_qt5_src}
     PRIVATE
         qfcitxplatforminputcontext.cpp
@@ -34,6 +37,7 @@
     target_compile_definitions(external_fcitx5_qt5
     PRIVATE
         QT_STATICPLUGIN
+        FCITX_PLUGIN_DATA_FILE_PATH="${CMAKE_CURRENT_BINARY_DIR}/fcitx5.json"
     )
 
     target_link_libraries(external_fcitx5_qt5

=== cmake/external/ffmpeg/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_ffmpeg INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_ffmpeg ALIAS external_ffmpeg)

if (DESKTOP_APP_USE_PACKAGED)
    find_package(PkgConfig REQUIRED)

    pkg_check_modules(AVCODEC REQUIRED IMPORTED_TARGET libavcodec)
    pkg_check_modules(AVFORMAT REQUIRED IMPORTED_TARGET libavformat)
    pkg_check_modules(AVUTIL REQUIRED IMPORTED_TARGET libavutil)
    pkg_check_modules(SWSCALE REQUIRED IMPORTED_TARGET libswscale)
    pkg_check_modules(SWRESAMPLE REQUIRED IMPORTED_TARGET libswresample)

    if (DESKTOP_APP_USE_PACKAGED_FFMPEG_STATIC)
        target_include_directories(external_ffmpeg
        INTERFACE
            ${AVCODEC_STATIC_INCLUDE_DIRS}
            ${AVFORMAT_STATIC_INCLUDE_DIRS}
            ${AVUTIL_STATIC_INCLUDE_DIRS}
            ${SWSCALE_STATIC_INCLUDE_DIRS}
            ${SWRESAMPLE_STATIC_INCLUDE_DIRS}
        )

        target_link_static_libraries(external_ffmpeg IGNORE_NONEXISTING
        INTERFACE
            ${AVCODEC_STATIC_LIBRARIES}
            ${AVFORMAT_STATIC_LIBRARIES}
            ${AVUTIL_STATIC_LIBRARIES}
            ${SWSCALE_STATIC_LIBRARIES}
            ${SWRESAMPLE_STATIC_LIBRARIES}
        )
    else()
        target_link_libraries(external_ffmpeg
        INTERFACE
            PkgConfig::AVCODEC
            PkgConfig::AVFORMAT
            PkgConfig::AVUTIL
            PkgConfig::SWSCALE
            PkgConfig::SWRESAMPLE
        )
    endif()
else()
    target_include_directories(external_ffmpeg SYSTEM
    INTERFACE
        ${libs_loc}/ffmpeg
    )

    set(ffmpeg_lib_loc ${libs_loc}/ffmpeg)

    target_link_libraries(external_ffmpeg
    INTERFACE
        ${ffmpeg_lib_loc}/libavformat/libavformat.a
        ${ffmpeg_lib_loc}/libavcodec/libavcodec.a
        ${ffmpeg_lib_loc}/libswresample/libswresample.a
        ${ffmpeg_lib_loc}/libswscale/libswscale.a
        ${ffmpeg_lib_loc}/libavutil/libavutil.a
        desktop-app::external_opus
    )
    if (LINUX)
        target_link_static_libraries(external_ffmpeg
        INTERFACE
            va-x11
            va-drm
            va
            vdpau
            Xi
            Xext
            Xfixes
            Xrender
        )
        target_link_libraries(external_ffmpeg
        INTERFACE
            drm
            pthread
        )
    endif()
endif()

=== cmake/external/openal/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_openal INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_openal ALIAS external_openal)

if (DESKTOP_APP_USE_PACKAGED)
    find_package(OpenAL REQUIRED)
    target_include_directories(external_openal INTERFACE ${OPENAL_INCLUDE_DIR})
    target_link_libraries(external_openal INTERFACE ${OPENAL_LIBRARY})
elseif (WIN32)
    target_include_directories(external_openal SYSTEM
    INTERFACE
        ${libs_loc}/openal-soft/include
        ${libs_loc}/openal-soft/include/AL
    )
    target_link_libraries(external_openal
    INTERFACE
        ${libs_loc}/openal-soft/build/$<IF:$<CONFIG:Debug>,Debug,Release>/OpenAL32.lib
    )
elseif(APPLE AND NOT build_osx)
    target_include_directories(external_openal SYSTEM
    INTERFACE
        /usr/local/macos/include
        /usr/local/macos/include/AL
    )
    target_link_libraries(external_openal
    INTERFACE
        /usr/local/macos/lib/libopenal.a
    )
else()
    target_include_directories(external_openal SYSTEM
    INTERFACE
        /usr/local/include
        /usr/local/include/AL
    )
    target_link_static_libraries(external_openal
    INTERFACE
        openal
    )
    target_link_libraries(external_openal
    INTERFACE
        ${CMAKE_DL_LIBS}
        pthread
    )
endif()

if (NOT DESKTOP_APP_USE_PACKAGED)
    target_compile_definitions(external_openal
    INTERFACE
        AL_LIBTYPE_STATIC
    )
endif()

target_compile_definitions(external_openal
INTERFACE
    AL_ALEXT_PROTOTYPES
)

=== cmake/external/ranges/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_ranges INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_ranges ALIAS external_ranges)

if (DESKTOP_APP_USE_PACKAGED AND NOT DESKTOP_APP_USE_PACKAGED_LAZY)
    find_package(range-v3 REQUIRED)
    target_link_libraries(external_ranges INTERFACE range-v3::range-v3)
else()
    target_include_directories(external_ranges SYSTEM
    INTERFACE
        ${third_party_loc}/range-v3/include
    )

    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        target_compile_options(external_ranges
        INTERFACE
            /Zc:preprocessor # need for range-v3 see https://github.com/ericniebler/range-v3#supported-compilers
            /wd5105 # needed for `/Zc:preprocessor`, suppressing C5105 "macro expansion producing 'defined' has undefined behavior"
        )
    endif()
endif()

=== debian/changelog ===
telegram-desktop (2.1.7+ds-2~ubuntu20.04.1) focal; urgency=medium

  * Backport from groovy to focal (LP: #1880307).
  * Revert "Switch to Hunspell spellchecker from Enchant".
    - Preserves current behaviour and leaves untouched user settings in
      existing installations.
  * New Backport-to-legacy-GSL.patch.
    - Needed for build against Microsoft Guidelines Support Library of version
      less than 3.0.0.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 30 May 2020 21:21:51 +0300

telegram-desktop (2.1.7+ds-2) unstable; urgency=medium

  * Rewrite Set-semibold-font.patch to fix lacking boldface
    in message input box under KDE.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 30 May 2020 19:28:39 +0300

telegram-desktop (2.1.7+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add Set-semibold-font.patch (Closes: #961526)
    - The patch partially fixes bold font in KDE. Although, boldface is still
      unused in the input box.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 26 May 2020 20:00:13 +0300

=== debian/control ===
--- 
+++ 
@@ -1,28 +1,28 @@
 Source: telegram-desktop
 Section: net
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: debhelper-compat (=12)
+Build-Depends: debhelper (>=12.8~), debhelper-compat (=12)
 Build-Depends-Arch:
  cmake (>=3.16.0),
  libavcodec-dev (>=7:3.2),
  libavformat-dev (>=7:3.2),
  libavutil-dev (>=7:3.2),
  libdbusmenu-qt5-dev,
+ libenchant-dev | libenchant-2-dev,
  libexpected-dev,
  libgtk2.0-dev,
- libhunspell-dev,
  liblz4-dev,
  liblzma-dev,
  libmapbox-variant-dev,
  libminizip-dev (>=1.1),
- libmsgsl-dev (>=3.0.0),
+ libmsgsl-dev (>=1.0.0), libmsgsl-dev (<<2.0.0) | libmsgsl-dev (>=2.1.0), libmsgsl-dev (<<3.0.0),
  libopenal-dev,
  libopus-dev (>=1.1),
  libqrcodegencpp-dev,
  librange-v3-dev (>=0.10.0),
- librlottie-dev (>= 0~git20200305.a717479~),
+ librlottie-dev,
  libssl-dev (>=1.0.1),
  libswresample-dev (>=7:3.2),
  libswscale-dev (>=7:3.2),
